﻿using System;

using UIKit;
using Syncfusion.SfDataGrid.DataPager;
using Syncfusion.SfDataGrid;
using CoreGraphics;
using System.IO;
using QuickLook;
using Foundation;
using System.Reflection;
using System.Diagnostics;

namespace ExportingSampleDemo
{
	public partial class ViewController : UIViewController
	{
		SfDataGrid SfGrid;
        public ViewController()
        {

            SfGrid = new SfDataGrid();
            SfGrid.AutoGenerateColumns = false;
            SfGrid.ItemsSource = new FormattingViewModel().BankInfo;
            SfGrid.ColumnSizer = ColumnSizer.Star;

            GridTextColumn customerImageColumn = new GridTextColumn();
            customerImageColumn.UserCellType = typeof(GridImageCell);
            customerImageColumn.MappingName = "CustomerImage";
            customerImageColumn.HeaderText = "Image";

            GridTextColumn isOpenColumn = new GridTextColumn();
            isOpenColumn.MappingName = "IsOpen";
            isOpenColumn.HeaderText = "Is Open";

            GridTextColumn balanceScaleColumn = new GridTextColumn();
            balanceScaleColumn.MappingName = "BalanceScale";
            balanceScaleColumn.HeaderText = "Balance Scale";

            GridTextColumn chartcell = new GridTextColumn();
            chartcell.MappingName = "Transactions";
            chartcell.HeaderText = "Transactions";

            GridTextColumn customerIdColumn = new GridTextColumn();
            customerIdColumn.MappingName = "CustomerID";
            customerIdColumn.HeaderText = "Customer ID";
            customerIdColumn.TextAlignment = UITextAlignment.Center;


            GridTextColumn currentColumn = new GridTextColumn();
            currentColumn.MappingName = "Current";
            currentColumn.TextAlignment = UITextAlignment.Center;

            GridTextColumn customerNameColumn = new GridTextColumn();
            customerNameColumn.MappingName = "CustomerName";
            customerNameColumn.HeaderText = "Customer Name";
            customerNameColumn.TextMargin = 10;
            customerNameColumn.TextAlignment = UITextAlignment.Left;

            GridTextColumn savingsColumn = new GridTextColumn();
            savingsColumn.MappingName = "Savings";
            savingsColumn.TextAlignment = UITextAlignment.Center;

            SfGrid.Columns.Add(chartcell);
            SfGrid.Columns.Add(customerImageColumn);
            SfGrid.Columns.Add(customerIdColumn);
            SfGrid.Columns.Add(currentColumn);
            SfGrid.Columns.Add(customerNameColumn);
            SfGrid.Columns.Add(savingsColumn);
            SfGrid.Columns.Add(balanceScaleColumn);
            SfGrid.Columns.Add(isOpenColumn);
          
            View.AddSubview(this.SfGrid);
        }

        public ViewController (IntPtr handle) : base (handle)
		{          
        }

        public override void ViewDidLoad ()
		{
			base.ViewDidLoad ();
            SfGrid.Frame = new CoreGraphics.CGRect(0, 0, View.Frame.Width, View.Frame.Height);
        }
	}

    public class GridImageCell : GridCell
    {
        private UIImageView imageview;
        CoreGraphics.CGRect framespec = new CoreGraphics.CGRect();

        public GridImageCell()
        {
            imageview = new UIImageView();
            this.CanRenderUnLoad = false;
        }

        protected override void UnLoad()
        {
            this.RemoveFromSuperview();
        }

       
        public override void LayoutSubviews()
        {
            base.LayoutSubviews();
            if (imageview.Superview == null)
            {
                this.AddSubview(imageview);
                framespec = new CoreGraphics.CGRect(20, 3, 60, (nfloat)DataColumn.Renderer.DataGrid.RowHeight - 5);
            }
            
            imageview.Frame = framespec;
            imageview.Image = (UIImage)DataColumn.RowData.GetType().GetProperty("CustomerImage").GetValue(DataColumn.RowData);
        }

        public override void Draw(CoreGraphics.CGRect rect)
        {
            base.Draw(rect);
        }

        protected override void Dispose(bool disposing)
        {
            this.imageview = null;
            base.Dispose(disposing);
        }
    }
}

